'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var fs = require('fs');
var path = require('path');
var crypto = require('crypto');
var chalk = require('react-dev-utils/chalk');
var paths = require('./paths');

// Ensure the certificate and key provided are valid and if not
// throw an easy to debug error
function validateKeyAndCerts(_ref) {
  var cert = _ref.cert,
    key = _ref.key,
    keyFile = _ref.keyFile,
    crtFile = _ref.crtFile;
  var encrypted;
  try {
    // publicEncrypt will throw an error with an invalid cert
    encrypted = crypto.publicEncrypt(cert, Buffer.from('test'));
  } catch (err) {
    throw new Error("The certificate \"".concat(chalk.yellow(crtFile), "\" is invalid.\n").concat(err.message));
  }
  try {
    // privateDecrypt will throw an error with an invalid key
    crypto.privateDecrypt(key, encrypted);
  } catch (err) {
    throw new Error("The certificate key \"".concat(chalk.yellow(keyFile), "\" is invalid.\n").concat(err.message));
  }
}

// Read file and throw an error if it doesn't exist
function readEnvFile(file, type) {
  if (!fs.existsSync(file)) {
    throw new Error("You specified ".concat(chalk.cyan(type), " in your env, but the file \"").concat(chalk.yellow(file), "\" can't be found."));
  }
  return fs.readFileSync(file);
}

// Get the https config
// Return cert files if provided in env, otherwise just true or false
function getHttpsConfig() {
  var _process$env = process.env,
    SSL_CRT_FILE = _process$env.SSL_CRT_FILE,
    SSL_KEY_FILE = _process$env.SSL_KEY_FILE,
    HTTPS = _process$env.HTTPS;
  var isHttps = HTTPS === 'true';
  if (isHttps && SSL_CRT_FILE && SSL_KEY_FILE) {
    var crtFile = path.resolve(paths.appPath, SSL_CRT_FILE);
    var keyFile = path.resolve(paths.appPath, SSL_KEY_FILE);
    var config = {
      cert: readEnvFile(crtFile, 'SSL_CRT_FILE'),
      key: readEnvFile(keyFile, 'SSL_KEY_FILE')
    };
    validateKeyAndCerts(_objectSpread(_objectSpread({}, config), {}, {
      keyFile: keyFile,
      crtFile: crtFile
    }));
    return config;
  }
  return isHttps;
}
module.exports = getHttpsConfig;