"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.build = void 0;
exports.getArg = getArg;
exports.startOnline = exports.start = exports.pluginDev = exports.plugin = exports.isVue = void 0;
var _fs = _interopRequireDefault(require("fs"));
var cwd = process.cwd();
var appConfigPath = cwd + "/app.config.js";
var config = {};
if (_fs["default"].existsSync(appConfigPath)) {
  config = require(appConfigPath);
}
function getArg(key) {
  var val = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var index = process.argv.indexOf(key);
  if (process.argv[index] && process.argv[index].indexOf("=") > 0) {
    return process.argv[index].split('=')[1];
  }
  var next = process.argv[index + 1];
  return index < 0 ? null : !next || next[0] === "-" ? val : next;
}
var start = getArg("start") || getArg("--start");
exports.start = start;
var build = getArg("build") || getArg("--build");
exports.build = build;
var plugin = getArg("plugin") || getArg("--plugin");
exports.plugin = plugin;
var isVue = getArg("isVue") || getArg("--isVue");
exports.isVue = isVue;
var startOnline = getArg("startOnline") || getArg("--start-online") || getArg("--startOnline");
exports.startOnline = startOnline;
var pluginDev = getArg("pluginDev") || getArg("--plugin-dev") || getArg("--pluginDev");
exports.pluginDev = pluginDev;