#!/usr/bin/env node
"use strict";

var _getArgs = require("./getArgs");
var childProcess = require("child_process");
var cwd = process.cwd();
var fs = require("fs");
var configJson = require(cwd + "/config.json");
var pluginType = configJson.type;
var templateType = configJson.templateType.toLowerCase() === 'react' ? 'react' : 'vue';
if (!fs.existsSync(cwd + '/output')) {
  fs.mkdirSync(cwd + '/output');
}
if (_getArgs.start) {
  if (_getArgs.isVue) {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " VUE_CLI_SERVICE_CONFIG_PATH=").concat(__dirname, "/vue.config.js vue-cli-service serve"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  } else {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " node ").concat(__dirname, "/scripts/start.js"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  }
}
if (_getArgs.startOnline) {
  if (_getArgs.isVue) {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " VUE_APP_ONLINE_DEVELOPMENT_MODE=true VUE_CLI_SERVICE_CONFIG_PATH=").concat(__dirname, "/vue.config.js vue-cli-service serve"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  } else {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " REACT_APP_ONLINE_DEVELOPMENT_MODE=true FAST_REFRESH=false node ").concat(__dirname, "/scripts/start.js"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  }
}
if (_getArgs.plugin || _getArgs.pluginDev) {
  childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " node ").concat(__dirname, "/scripts/predev"), {
    async: false,
    stdio: "inherit",
    stderr: "inherit"
  });
  if (!_getArgs.pluginDev) {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " node ").concat(__dirname, "/scripts/prebuild"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  }
  if (_getArgs.isVue) {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " VUE_APP_ONLINE_DEVELOPMENT_MODE=").concat(_getArgs.pluginDev, " VUE_CLI_SERVICE_CONFIG_PATH=").concat(__dirname, "/vue.config.js vue-cli-service build"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  } else {
    childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " REACT_APP_NEEDSOURCEMAP=false node ").concat(__dirname, "/scripts/build.js"), {
      async: false,
      stdio: "inherit",
      stderr: "inherit"
    });
  }
  childProcess.execSync("cross-env PLUGIN_TYPE=".concat(pluginType, " TEMPLATE_TYPE=").concat(templateType, " node ").concat(__dirname, "/scripts/genPlugin.js --source=").concat(_getArgs.pluginDev ? 'true' : 'false'), {
    async: false,
    stdio: "inherit",
    stderr: "inherit"
  });
}