"use strict";

var cwd = process.cwd();
var configJson = require(cwd + "/config.json");
var inquirer = require("inquirer");
var fs = require("fs");
var chalk = require("chalk");
var sysPath = require("path");
var infomation = require(__dirname + "/../information.json");
module.exports = function checkOnlineDevelopment() {
  if (configJson["online-development-mode"].open === true) {
    inquirer.prompt([{
      type: "list",
      name: "isProd",
      message: chalk.red("风险警告，检测到config.json中online-development-mode字段open为true，此配置仅在开发时线上调试使用，如果流入生产环境将会使该组件boom，是否将open字段置为false并继续执行打包操作"),
      choices: [{
        name: "从善如流，我确实想打生产包",
        value: true
      }, {
        name: "一意孤行，我就是要打调试包",
        value: false
      }]
    }]).then(function (answer) {
      if (answer.isProd === true) {
        configJson["online-development-mode"].open = false;
        fs.writeFileSync(sysPath.resolve(cwd + "/config.json"), JSON.stringify(configJson, null, 2), "utf8");
      } else {
        infomation.onlineDevMode = true;
        fs.writeFileSync(sysPath.resolve(__dirname + "/../information.json"), JSON.stringify(infomation, null, 2), "utf8");
      }
    });
  }
};