import fs from "fs";
const cwd = process.cwd();

let appConfigPath = cwd + "/app.config.js";
let config = {};
if (fs.existsSync(appConfigPath)) {
  config = require(appConfigPath);
}

export function getArg(key, val = true) {
  var index = process.argv.indexOf(key);
  if(process.argv[index] && process.argv[index].indexOf("=") > 0){
    return process.argv[index].split('=')[1];
  }
  var next = process.argv[index + 1];
  return index < 0 ? null : !next || next[0] === "-" ? val : next;
}

export let start = getArg("start") || getArg("--start");
export let build = getArg("build") || getArg("--build");
export let plugin = getArg("plugin") || getArg("--plugin");
export let isVue = getArg("isVue") || getArg("--isVue");
export let startOnline = getArg("startOnline") || getArg("--start-online")|| getArg("--startOnline");
export let pluginDev = getArg("pluginDev") || getArg("--plugin-dev")|| getArg("--pluginDev");
