const exec = require("child_process").execSync
const os = require("os")
const fs = require("fs")
const path = require("path")
const cwd = process.cwd();
const information = require(__dirname + "/../information.json")
module.exports = function writeInformation() {
  information.developers = getDevelopers()
  information.ipAdress = getIpAddress()
  fs.writeFileSync(
    path.resolve(__dirname + "/../information.json"),
    JSON.stringify(information, null, 2),
    "utf8"
  )
}

function getDevelopers() {
  let preDevelopers = information.developers
  let developers = ""
  let currentDeveloper = ""
  try {
    currentDeveloper = exec("git config user.name", { "encoding": "utf8" }).replace("\n", "")
  } catch (e) {
    console.log(e)
  }
  if (preDevelopers) {
    if (preDevelopers.split(",").includes(currentDeveloper)) {
      developers = preDevelopers
    } else {
      developers = `${preDevelopers},${currentDeveloper}`
    }
  } else {
    developers = currentDeveloper
  }
  return developers
}

function getIpAddress() {
  var ifaces = os.networkInterfaces()
  for (var dev in ifaces) {
    let iface = ifaces[dev]
    for (let i = 0; i < iface.length; i++) {
      let { family, address, internal, mac } = iface[i]
      if (family === "IPv4" &&
          address !== "127.0.0.1" &&
          !internal &&
          mac !== "00:00:00:00:00:00"
      ) {
        return address
      }
    }
  }
}
